.\" $NetBSD: aio_suspend.3,v 1.2 2007/05/05 19:16:01 ad Exp $
.\"
.\" Copyright (c) 1999 Softweyr LLC.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY Softweyr LLC AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL Softweyr LLC OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\" $FreeBSD: /repoman/r/ncvs/src/lib/libc/sys/aio_suspend.2,v 1.22 2004/12/23 23:45:25 keramida Exp $
.\"
.Dd May 4, 2007
.Dt AIO_SUSPEND 3
.Os
.Sh NAME
.Nm aio_suspend
.Nd suspend until asynchronous I/O operations or timeout complete (REALTIME)
.Sh LIBRARY
.Lb librt
.Sh SYNOPSIS
.In aio.h
.Ft int
.Fn aio_suspend "const struct aiocb * const list[]" "int nent" "const struct timespec * timeout"
.Sh DESCRIPTION
The
.Fn aio_suspend
system call suspends the calling process until at least one of the
specified asynchronous I/O requests have completed, a signal is
delivered, or the
.Fa timeout
has passed.
.Pp
The
.Fa list
argument
is an array of
.Fa nent
pointers to asynchronous I/O requests.
Array members containing
null pointers will be silently ignored.
.Pp
If
.Fa timeout
is not a null pointer, it specifies a maximum interval to suspend.
If
.Fa timeout
is a null pointer, the suspend blocks indefinitely.
To effect a
poll, the
.Fa timeout
should point to a zero-value timespec structure.
.Sh RETURN VALUES
If one or more of the specified asynchronous I/O requests have
completed,
.Fn aio_suspend
returns 0.
Otherwise it returns \-1 and sets
.Va errno
to indicate the error, as enumerated below.
.Sh ERRORS
The
.Fn aio_suspend
system call will fail if:
.Bl -tag -width Er
.It Bq Er EAGAIN
The
.Fa timeout
expired before any I/O requests completed.
.It Bq Er EINTR
The suspend was interrupted by a signal.
.It Bq Er EINVAL
The
.Fa list
argument
contains more than
.Dv AIO_LISTIO_MAX
asynchronous I/O requests, or at least one of the requests is not
valid.
.El
.Sh SEE ALSO
.Xr aio_cancel 3 ,
.Xr aio_error 3 ,
.Xr aio_return 3 ,
.Xr aio_write 3
.Sh STANDARDS
The
.Fn aio_suspend
system call
is expected to conform to the
.St -p1003.1-2001
standard.
.Sh HISTORY
The
.Fn aio_suspend
system call first appeared in
.Nx 5.0 .
